(PackageInfo named: 'acceptit') preamble: 'nil'!
SystemOrganization addCategory: #'acceptit-Compiler'!
SystemOrganization addCategory: #'acceptit-Core-Model'!
SystemOrganization addCategory: #'acceptit-Tests'!
SystemOrganization addCategory: #'acceptit-Tests-Fixtures'!
(PackageInfo named: 'acceptit') postscript: '"below, add code to be run after the loading of this package"
'!

WAComponent subclass: #ACTestRootComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests-Fixtures'!

!ACTestRootComponent class methodsFor: 'as yet unclassified' stamp: 'topa 6/9/2010 12:49'!
canBeRoot

^true! !

!ACTestRootComponent class methodsFor: 'as yet unclassified' stamp: 'topa 6/9/2010 13:01'!
registerApplication

^WAAdmin 
		register: self
		asApplicationAt: 'ACTest'.! !

!ACTestRootComponent methodsFor: 'as yet unclassified' stamp: 'topa 6/23/2010 15:45'!
renderContentOn: html
 "I render everything by calling html"

	html paragraph: 'Hello World'.! !

ATestCase subclass: #ACUserStory
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Model'!

ACUserStory class
	instanceVariableNames: 'purpose role means userStoryString'!

ACUserStory class
	instanceVariableNames: 'purpose role means userStoryString'!

ACUserStory subclass: #ACMyTestClass4
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Model'!

ACUserStory subclass: #ACToDoAppTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Core-Model'!

!ACToDoAppTests methodsFor: 'as yet unclassified' stamp: 'fg 6/29/2010 15:29'!
create Task
Given I am logged in
When I create a New Task
Then I can see the created Task
! !

!ACToDoAppTests methodsFor: 'as yet unclassified' stamp: 'fg 6/29/2010 15:28'!
emptyTodoSet
Given I am logged in
When I click on All and I don't have any todos
Then I see nothing! !

!ACToDoAppTests methodsFor: 'as yet unclassified' stamp: 'fg 6/29/2010 15:13'!
Login test
Given I have a Web Site
When I go to the Web Site
Then I have to login! !

!ACToDoAppTests methodsFor: 'as yet unclassified' stamp: 'fg 6/29/2010 15:16'!
login with correct credentials
Given I have Credentials
When I login
Then I want to see my personal Page! !

!ACToDoAppTests methodsFor: 'as yet unclassified' stamp: 'fg 6/29/2010 15:14'!
No Credentials test
Given I have a Web Site
When I have no credentials
Then I have to register
! !

!ACToDoAppTests methodsFor: 'as yet unclassified' stamp: 'fg 6/29/2010 15:30'!
Select task
Given I am logged in and I have a Task
When I click on the task
Then I can edit the task! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'db 6/22/2010 16:16'!
allTestSelectors

	^ (Pragma allNamed: #scenario in: self)
			collect: [:pragma | pragma selector]
! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/14/2010 12:41'!
compilerClass
		
	^ self looksLikeUserStoryHeir
		ifTrue: [	ACCompiler]
		ifFalse: [super compilerClass]
! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/29/2010 15:13'!
definition

	^ self == ACUserStory
		ifTrue: [super definition]
		ifFalse: [String streamContents: [:stream |
			stream
				nextPutAll: self userStoryString printString;  crtab;
				nextPutAll: 'as: ';
				nextPutAll: (super definition findTokens: ' ') first]]
				
"				nextPutAll: (super definition findTokens: ' ') first; space;
				nextPutAll: 'named: '; nextPutAll: self name printString; crtab;
				nextPutAll: 'purpose: '; nextPutAll: self purpose printString; crtab;
				nextPutAll: 'role: '; nextPutAll: self role printString; crtab;
				nextPutAll: 'means: '; nextPutAll: self means printString"! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:23'!
isAbstract

	^ self == ACUserStory! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/14/2010 12:46'!
looksLikeUserStoryHeir
	"During recompilation of the ACUserStory class, all of
	#==, #inheritsFrom:, or #isKindOf: will fail, so we have to rely
	on the name of the class and walk the superclasses ourselves"
	
	self allSuperclassesDo: [:cls |
		cls name = #ACUserStory
			ifTrue: [^ true]].
	^ false! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
means

	^means! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
means: anObject

	means := anObject! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 12:48'!
named: aNameSymbol
purpose: purposeString
role: roleString
means: meansString

	|klass|		
	klass := self subclass: aNameSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: self category.
	klass purpose: purposeString; role: roleString; means: meansString.
	
	^ klass! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/8/2010 14:03'!
newFrom: anObject

	(anObject isKindOf: String)
		ifTrue: [^ self userStoryFromString: anObject].

	^ super newFrom: anObject! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/14/2010 12:46'!
parserClass

	self == ACUserStory
		ifFalse: [
			" this is only necessary to avoid a (inapplicable) warning from the Browser"
			 ((thisContext client isKindOf: Browser) and: [
				thisContext sender selector = #validateMessageSource:forSelector:])
					ifTrue: [^ACParser]].
	^ super parserClass
! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
purpose

	^purpose! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
purpose: anObject

	purpose := anObject! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
role

	^role! !

!ACUserStory class methodsFor: 'accessing' stamp: 'topa 6/3/2010 12:42'!
role: anObject

	role := anObject! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/14/2010 15:02'!
shoutParserClass

	^ (self inheritsFrom: ACUserStory)
		ifTrue: [ACParser]
		ifFalse: [super shoutParserClass]! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/29/2010 15:11'!
userStoryFromString: anObject

	^ (Compiler 
		evaluate: (ACTranslator 
			match: (ACParser matchAll: anObject readStream with: #userStory withArgs: #()) 
			with: #translate)
		notifying: nil 
		logged: true)
		userStoryString: anObject! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/29/2010 15:12'!
userStoryString

	^ userStoryString! !

!ACUserStory class methodsFor: 'as yet unclassified' stamp: 'topa 6/29/2010 15:11'!
userStoryString: aString

	userStoryString := aString.! !

!ACUserStory methodsFor: 'as yet unclassified' stamp: 'db 6/22/2010 16:39'!
given: aString

	(aString = 'I have a web site')
		ifTrue: [
			WASwazooAdaptor startOn: 9999. 
			ACTestRootComponent registerApplication.
			(Delay forMilliseconds: 500) wait.
			
			self wrapper port: 9999.
			super setUp. "call albatross setup here when our app is set up"
			].! !

!ACUserStory methodsFor: 'as yet unclassified' stamp: 'db 6/22/2010 16:43'!
runCase
	"Run this TestCase. Time out if the test takes too long."

	[
	"self timeout:["
		self setUp.
		self performTest
	"] after: self timeoutForTest"
	] ensure:[self tearDown].! !

!ACUserStory methodsFor: 'as yet unclassified' stamp: 'db 6/22/2010 16:32'!
setUp

	"avois calling of albatros' setup"! !

!ACUserStory methodsFor: 'as yet unclassified' stamp: 'db 6/22/2010 15:59'!
subjectApplication
	^WADispatcher default entryPointAt: '/ACTest'! !

!ACUserStory methodsFor: 'as yet unclassified' stamp: 'topa 6/17/2010 15:26'!
tearDown

	| adaptor |
	"WAAdmin unregister: 'ACTest'."
	WADispatcher default unregister: 'ACTest'.
	adaptor := WAAdmin serverAdaptors detect: [:a | a port = 9999] ifNone: [nil].
	adaptor ifNotNil: [:a|
		a isRunning ifTrue: [ a stop ].
		(Delay forMilliseconds: 250) wait.
		(a isRunning or: [a isStopping]) ifTrue: [a kill]	].! !

!ACUserStory methodsFor: 'as yet unclassified' stamp: 'topa 6/23/2010 15:46'!
then: aString

	('I see "*"' match: aString)
		ifTrue: [|subString|
				subString:= aString copyFrom: 8 to: aString size - 1.
				self assert: (browser textExists: subString)].
! !

!ACUserStory methodsFor: 'as yet unclassified' stamp: 'db 6/22/2010 16:50'!
when: aString

	(aString = 'I go to the web site')
		ifTrue: [
			"result := (HTTPClient httpGet: 'http://localhost:9999/ACTest') contents" "implicit w/ albatross"
			self wrapper port: nil.
			].
	! !

OMeta2 subclass: #ACParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Compiler'!

!ACParser methodsFor: 'helpers' stamp: 'topa 5/18/2010 18:05'!
charNoNewline =

	<char:x ?[x ~= Character cr]>! !

!ACParser methodsFor: 'parsing' stamp: 'topa 6/3/2010 15:11'!
endOfLastToken

	^ 'scenario1' size! !

!ACParser methodsFor: 'scenario-rules' stamp: 'topa 5/27/2010 14:55'!
givenLine =

	 spaces <``Given''> spaces <charNoNewline+>:body -> [{#given . body}]! !

!ACParser methodsFor: 'helpers' stamp: 'topa 5/18/2010 17:51'!
lineEnd =

	<char:x ?[x = Character cr]>! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/20/2010 09:39'!
meansLine =

	spaces <``I want'' `` to''?> spaces <charNoNewline+>:body -> [{#means . body}]! !

!ACParser methodsFor: 'parsing' stamp: 'topa 6/3/2010 15:10'!
parseSelector: aByteString 
	^ 'scenario1'! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/19/2010 13:02'!
purposeLine =

	 spaces <``In order to''> spaces <charNoNewline+>:body -> [{#purpose . body}]! !

!ACParser methodsFor: 'shout' stamp: 'topa 6/14/2010 15:02'!
rangesIn: sourceString classOrMetaClass: aBehaviour workspace: aWorkspace  environment: anEnvironmentOrNil

	^ nil! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/19/2010 13:02'!
roleLine =

		 spaces <``As a'' ``n''?> spaces <charNoNewline+>:body -> [{#role . body}]! !

!ACParser methodsFor: 'scenario-rules' stamp: 'fg 6/15/2010 11:09:03.57'!
scenario =

	title:t lineEnd+
	givenLine:given lineEnd
	whenLine:when lineEnd
	thenLine:then lineEnd? end -> [{#scenario. t. given. when. then}]
	! !

!ACParser methodsFor: 'helpers' stamp: 'topa 5/20/2010 09:59'!
space =
	// we do not allow newline as whitespace
	
	^space:s ?[ ({Character cr. Character lf} noneSatisfy: [:c | c =s ])]! !

!ACParser methodsFor: 'scenario-rules' stamp: 'topa 5/27/2010 14:55'!
thenLine =

	 spaces <``Then''> spaces <charNoNewline+>:body -> [{#then . body}]! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/19/2010 13:02'!
title =

	<charNoNewline+>:body -> [{#title . body}]! !

!ACParser methodsFor: 'userStory-rules' stamp: 'topa 5/20/2010 10:03'!
userStory =
	
	title:t lineEnd+
	purposeLine:purpose lineEnd
	roleLine:role lineEnd
	meansLine:means lineEnd? end -> [{#userStory. t. purpose. role. means}]
	! !

!ACParser methodsFor: 'scenario-rules' stamp: 'topa 5/27/2010 14:55'!
whenLine =

	 spaces <``When''> spaces <charNoNewline+>:body -> [{#when . body}]! !

OMeta2 subclass: #ACTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Compiler'!

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:27'!
messagePart =

	{symbol:s string:body} -> ['	', s asMutator,' ''', body,'''', String cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'fg 6/29/2010 15:28'!
rule =

	{symbol:s string:body} -> ['	self ', s asMutator,' ', body printString,'.', String cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'fg 6/15/2010 15:20:38.788'!
scenarioAnnotation

	^ String streamContents: [:stream |
		stream crtab; 	nextPutAll: '<scenario>'; cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'topa 6/3/2010 13:35'!
title =

	{symbol:t string:s} -> ['ACUserStory named: ', s asLegalSelector capitalized asSymbol printString, String cr]! !

!ACTranslator methodsFor: 'as yet unclassified' stamp: 'fg 6/15/2010 15:31:49.937'!
translate =
	
	{symbol:type ?[type = #userStory] title:t messagePart:purpose messagePart:role messagePart:means}
		-> [t, purpose, role, means]
|	{symbol:type ?[type = #scenario] {symbol:ign string:t} rule:given rule:when rule:then}
		-> [t asLegalSelector, self scenarioAnnotation, given, when, then]! !

Compiler subclass: #ACCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Compiler'!

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 12:18'!
compile: origCode in: cls classified: aCategory notifying: notify ifFail: failBlock

	^ self compile: origCode in: cls notifying: notify ifFail: failBlock! !

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'fg 6/15/2010 16:13:11.553'!
compile: origCode in: cls notifying: notify ifFail: failBlock

	| origCodeStream translatedCode |
	origCodeStream := origCode asString readStream.
	self from: origCodeStream class: cls context: nil notifying: notify.
	[ | parseTree |
			
		parseTree := self parserClass matchStream: origCodeStream with: #scenario withArgs: #() withPlaybackDebugging: false.
		translatedCode := ACTranslator match: parseTree with: #translate.
	] on: OM2Fail do: [:ignore |
		self notify: '<-- parse error around here -->' at: origCodeStream position.
		^ failBlock value
	].
	^ Compiler new
		compile: translatedCode readStream
		in: cls
		notifying: notify
		ifFail: failBlock! !

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'fg 6/15/2010 16:08:20.587'!
parse: aStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock

	^ [
		| parseTree translatedCode code |
		parseTree := self parserClass matchStream: aStream with: #userStory withArgs: #() withPlaybackDebugging: false.
		translatedCode := ACTranslator match: parseTree with: #translate.
		Parser new parse: translatedCode readStream class: aClass noPattern: noPattern context: ctxt notifying: req ifFail: aBlock
	] on: OM2Fail do: [aBlock value]! !

!ACCompiler methodsFor: 'as yet unclassified' stamp: 'topa 5/19/2010 12:31'!
parserClass

	^ ACParser! !

TestCase subclass: #ACCompilerScenarioTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACCompilerScenarioTest methodsFor: 'as yet unclassified' stamp: 'fg 6/15/2010 15:47:47.591'!
testScenarioCompilation

	|scenario acMethod stMethod scenarioDecompiled |
	scenario := 'hello
		Given I have a web site
		When I go to the web site
		Then I see "Hello World"'.
	
	scenarioDecompiled := 'hello
		<scenario>
		self given: ''I have a web site''.
		self when: ''I go to the web site''.
		self then: ''I see "Hello World"''.'.
	
	acMethod := ACCompiler new compile:  scenario  in: self class classified: nil notifying: nil ifFail: [].
	stMethod := Compiler new compile: scenarioDecompiled in: self class classified: nil notifying: nil ifFail: [].
	self 
		should: [acMethod selector = stMethod selector];
		should: [acMethod decompileString = stMethod decompileString].! !

!ACCompilerScenarioTest methodsFor: 'as yet unclassified' stamp: 'fg 6/15/2010 16:33:35.829'!
testScenarioHasCorrectName

	|scenario acMethod |
	scenario := 'Here should be the name of the method
		Given I have a web site
		When I go to the web site
		Then I see "Hello World"'.
		
	acMethod := ACCompiler new compile:  scenario  in: self class classified: nil notifying: nil ifFail: [].
	
	self 
		should: [acMethod selector =  'hereshouldbethenameofthemethod'].
		 ! !

TestCase subclass: #ACCompilerUserStoryTest
	instanceVariableNames: 'klassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACCompilerUserStoryTest methodsFor: 'helper' stamp: 'topa 6/3/2010 14:07'!
directClassWithVariablesSet

	| theKlass |
	theKlass := (ACUserStory subclass: self klassName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: ACUserStory category).
	^ theKlass purpose: 'impress the ladies'; role: 'Casanova'; means: 'Prosecco'.! !

!ACCompilerUserStoryTest methodsFor: 'accessing' stamp: 'topa 6/3/2010 13:55'!
klassName

	^ klassName! !

!ACCompilerUserStoryTest methodsFor: 'accessing' stamp: 'topa 6/3/2010 13:55'!
klassName: anObject

	klassName := anObject! !

!ACCompilerUserStoryTest methodsFor: 'helper' stamp: 'topa 6/3/2010 14:01'!
parseTree

	^ ACTranslator match: (ACParser matchStream: 
'A Name For Testing
In order to impress the ladies
As a Casanova
I want Prosecco
' readStream with: #userStory withArgs: #() withPlaybackDebugging: false) with: #translate! !

!ACCompilerUserStoryTest methodsFor: 'helper' stamp: 'topa 6/3/2010 14:08'!
removeTestClass

	self klassName ifNotNilDo: [:name | 
		(Smalltalk globals at: name ifAbsent: [^ self]) removeFromSystemUnlogged].! !

!ACCompilerUserStoryTest methodsFor: 'running' stamp: 'topa 6/3/2010 13:57'!
setUp

	self klassName: #ANameForTesting.! !

!ACCompilerUserStoryTest methodsFor: 'running' stamp: 'topa 6/3/2010 14:02'!
tearDown

	self removeTestClass.! !

!ACCompilerUserStoryTest methodsFor: 'testing' stamp: 'fg 6/11/2010 14:16:34.89'!
testUserStoryCompilation

	| direct indirect generated |
	direct := self directClassWithVariablesSet definition.
	self removeTestClass.
	indirect := (ACUserStory named: self klassName
		purpose: 'impress the ladies' 
		role: 'Casanova'
		means: 'Prosecco') definition.
	self removeTestClass.
	generated := (Compiler evaluate: self parseTree notifying: nil logged: false) definition.
	self removeTestClass.
	
	self 
		should: [direct = indirect];
		should: [indirect = generated].! !

TestCase subclass: #ACParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

ACParserTest subclass: #ACParserScenarioTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:09:29.211'!
testScenarioGiven

|given|
given:= 'Given I have a web site'.

		self should: [self match: given with: #givenLine].	! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/11/2010 14:35:50.72'!
testScenarioInvalidNewlinesMatch

|scenarioInvalidNewlines|
	
	scenarioInvalidNewlines := 'Given I have a web site
	
		When I go to the web site
		
		Then I see "Hello World"'.
	self shouldnt: [self match:  scenarioInvalidNewlines with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/11/2010 14:12:03.478'!
testScenarioInvalidOrderMatch

|scenarioInvalidOrder|

	scenarioInvalidOrder:= 'When I go to the web site
		Given I have a web site
		Then I see "Hello World"'.
	self shouldnt: [self match: scenarioInvalidOrder with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/11/2010 14:12:51.013'!
testScenarioInvalidSyntaxMatch
|scenarioInvalidSyntax|

	scenarioInvalidSyntax:= 'Gvien I have a web site
		Wehn I go to the web site
		Tehn I see "Hello World"'.
	self shouldnt: [self match: scenarioInvalidSyntax with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/11/2010 14:13:37.893'!
testScenarioInvalidTrailersMatch

|scenarioInvalidTrailers|
scenarioInvalidTrailers:= 'Given I have a web site
	When I go to the web site
	Then I see "Hello World"
	Yes, This would be awesome.'.
	
	self shouldnt: [self match: scenarioInvalidTrailers with: #scenario].
		! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/15/2010 15:49:01.644'!
testScenarioMatch
|scenario|

	scenario:= 'Hello World
	Given I have a web site
	When I go to the web site
	Then I see "Hello World"'.
	self should: [self match: scenario with: #scenario].
! !

!ACParserScenarioTest methodsFor: 'tests-Scenario' stamp: 'fg 6/15/2010 16:30:43.661'!
testScenarioMissingName
|scenario|

	scenario:= '	Given I have a web site
	When I go to the web site
	Then I see "Hello World"'.
	self shouldnt: [self match: scenario with: #scenario].
! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:15:31.495'!
testScenarioThen
	
	|then|
	then := 'Then I see "Hello World"'.
	
	self should: [self match: then with: #thenLine].	! !

!ACParserScenarioTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:16:08.326'!
testScenarioWhen

	|when|
	when:= 'When I go to the web site'.
	self should: [self match: when with: #whenLine].	! !

!ACParserTest class methodsFor: 'as yet unclassified' stamp: 'topa 5/27/2010 14:50'!
isAbstract

	^ self == ACParserTest! !

!ACParserTest methodsFor: 'helpers' stamp: 'topa 5/27/2010 14:48'!
match: aString with: aRule

	[ACParser matchAll: aString with: aRule]
		on: OM2Fail
		do: [^ false].
	^ true! !

ACParserTest subclass: #ACParserUserStoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:36:39.815'!
testUserStoryInvalidNewlinesMatch

	|userStoryInvalidNewlines|
	userStoryInvalidNewlines :='A Title
		In order to achieve something
		
		As a role
		
		I want to do something.'.
	self shouldnt: [self match: userStoryInvalidNewlines with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:18:37.474'!
testUserStoryInvalidOrderMatch

	|userStoryInvalidOrder|
	userStoryInvalidOrder := 'A Title
		As a role
		I want to do something
		In order to achieve something.'.
	self shouldnt: [self match: userStoryInvalidOrder with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:19:35.46'!
testUserStoryInvalidSyntaxMatch

	|userStoryInvalidSyntax|
	userStoryInvalidSyntax := 'A Title
		In roder to achieve something
		Asa role
		I wnat ot do something.'.
	self shouldnt: [self match: userStoryInvalidSyntax with: #userStory].
	self flag: #extend. "topa: should look for position of invalid syntax"! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:20:19.864'!
testUserStoryInvalidTrailersMatch

	|userStoryInvalidTrailers|
	userStoryInvalidTrailers := 'A Title
		In order to achieve something
		As a role
		I want to do something.
	
		This is cool
		'.
	self shouldnt: [self match: userStoryInvalidTrailers with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:21:18.908'!
testUserStoryMatch

	|userStory|
	userStory := 'A Title
		In order to achieve something
		As a role
		I want to do something.'.
	self should: [self match: userStory with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:22:37.873'!
testUserStoryMeansMatch

	|means|
	means:= 'I want to do something.'.
	self should: [self match: means with: #meansLine].	! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:23:49.879'!
testUserStoryMeansOptionalToMatch

	|meansOptionalTo|
	meansOptionalTo := 'I want a cake.'.
	self should: [  self match: meansOptionalTo with: #meansLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:24:39.316'!
testUserStoryMeansOptionalToWithAnMatch

|meansOptionalToWithAn|
	meansOptionalToWithAn :='I want an embedded sleeping hour.'.
	self should: [  self match: meansOptionalToWithAn with: #meansLine].! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:26:24.557'!
testUserStoryMissingArgsMatch

	|userStoryMissingArgs|
	userStoryMissingArgs := 'A Title
		In order to
		As a
		I want'.
	self shouldnt: [self match: userStoryMissingArgs with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:27:38.785'!
testUserStoryNewlineAfterTitleMatch
	
	|userStoryNewlineAfterTitle|
	userStoryNewlineAfterTitle := 'A Title

		In order to achieve something
		As a role
		I want to do something.'.
	self should: [self match:  userStoryNewlineAfterTitle with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:28:44.094'!
testUserStoryPurposeMatch

	|purpose|
	purpose := 'In order to achieve something.'.
	self should: [  self match: purpose with: #purposeLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:29:30.091'!
testUserStoryRoleMatch

	|role|
	role :=  'As a role'.
	self should: [ self match: role with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:30:09.156'!
testUserStoryRoleWithAnMatch

	|roleWithAn|
	roleWithAn := 'As an emancipated role'.
	self should: [ self match: roleWithAn with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'fg 6/11/2010 14:30:47.067'!
testUserStoryRoleWithPluralMatch
	
	|roleWithPlural|
	roleWithPlural:='As roles'.
	self shouldnt: [ self match: roleWithPlural with: #roleLine].! !

!ACParserUserStoryTest methodsFor: 'tests-UserStory' stamp: 'fg 6/11/2010 14:31:33.05'!
testUserStorySpacingMatch
	
	|userStorySpacing|
	userStorySpacing := 
	'A Title
	    In order to achieve something
		As a role
	 	 I want to do something.'.
	self should: [self match: userStorySpacing with: #userStory].
		! !

!ACParserUserStoryTest methodsFor: 'tests-singleLine' stamp: 'topa 5/19/2010 12:22'!
testUserStoryTitleMatch

	self should: [self match: 'A Title' with: #title].	! !

TestCase subclass: #ACTranslatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 5/27/2010 15:40'!
testGivenTranslation

	|pt sourceCode|
	
	pt:= #(given 'I have a web site').
	sourceCode:= '	self given: ''I have a web site''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:39'!
testMeansTranslation

	| pt |
	pt:= #(means 'do something.').
	self should: (ACTranslator match: pt with: #messagePart) = ('	means: ''do something.''', String cr).! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:40'!
testPurposeTranslation

	| pt |
	pt:= #(purpose 'achieve something').
	self should: (ACTranslator match: pt with: #messagePart) = ('	purpose: ''achieve something''', String cr).
	! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:41'!
testRoleTranslation

	| pt |
	pt:= #(role 'role').
	self should: (ACTranslator match: pt with: #messagePart) = ('	role: ''role''', String cr).! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'fg 6/15/2010 16:14:45.921'!
testScenarioTranslation

	|pt sourceCode |
	
	
	pt:=#(#scenario 
			#(#title 'hello')
			#(#given 'I have a web site')
			#(#when 'I go to the web site')
			#(#then 'I see "Hello World"')).		
	sourceCode:= 'hello
	<scenario>
	self given: ''I have a web site''.
	self when: ''I go to the web site''.
	self then: ''I see "Hello World"''.', String cr.
	self should: (ACTranslator match: pt with: #translate) = sourceCode.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 5/27/2010 15:45'!
testThenTranslation

	|pt sourceCode|
	
	pt:= #(then 'I see "Hello World"').
	sourceCode:= '	self then: ''I see "Hello World"''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/3/2010 13:42'!
testTitleTranslation

	| pt |
	pt:= #(title 'A Title').
	self should: (ACTranslator match: pt with: #title) = ('ACUserStory named: #ATitle', String cr).! !

!ACTranslatorTest methodsFor: 'tests-userstory' stamp: 'topa 6/14/2010 12:06'!
testUserStoryTranslation

	| pt source |
	pt:= #(userStory
		#(title 'A Title') 
		#(purpose 'achieve something') 
		#(role 'role') 
		#(means 'do something.')).
	source := 'ACUserStory named: #ATitle
	purpose: ''achieve something''
	role: ''role''
	means: ''do something.''
'.
	self should: (ACTranslator match: pt with: #translate) = source.! !

!ACTranslatorTest methodsFor: 'test-scenario' stamp: 'topa 5/27/2010 15:40'!
testWhenTranslation

	|pt sourceCode|
	
	pt:= #(when 'I go to the web site').
	sourceCode:= '	self when: ''I go to the web site''.', String cr.
	self should: (ACTranslator match: pt with: #rule) = sourceCode.! !

TestCase subclass: #ACVerticalPrototypeTest
	instanceVariableNames: 'klassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'acceptit-Tests'!

!ACVerticalPrototypeTest methodsFor: 'accessing' stamp: 'topa 6/17/2010 13:16'!
klassName

	^klassName! !

!ACVerticalPrototypeTest methodsFor: 'accessing' stamp: 'topa 6/17/2010 13:16'!
klassName: anObject

	klassName := anObject! !

!ACVerticalPrototypeTest methodsFor: 'helper' stamp: 'fg 6/10/2010 19:57:56.355'!
removeTestClass: clsName

	clsName ifNotNilDo: [:name |
		(Smalltalk globals at: name ifAbsent: [^ self]) removeFromSystemUnlogged].! !

!ACVerticalPrototypeTest methodsFor: 'running' stamp: 'topa 6/17/2010 13:18'!
setUp

	super setUp.
	self klassName: #ACMyTestClass.
	"ensure its not there"
	self removeTestClass: self klassName.
! !

!ACVerticalPrototypeTest methodsFor: 'running' stamp: 'topa 6/17/2010 13:18'!
tearDown

	self removeTestClass: self klassName.
	super tearDown.! !

!ACVerticalPrototypeTest methodsFor: 'testing' stamp: 'topa 6/17/2010 14:48'!
testVerticalPrototype

	| userStory scenario numOfMethods storedMethod |

	userStory := 'AC My Test Class
		In order to deal with UserStories
		As a developer
		I want generated classes from Userstories' as: ACUserStory.
	self 
		should: [userStory inheritsFrom: TestCase];
		should: [userStory name = self klassName].
	
	numOfMethods := userStory methodDict size.
	scenario := userStory compile: 
'Hello World Test
Given I have a web site
When I go to the web site
Then I see "Hello World"'
						 classified: nil.
	self 
		should: [userStory methodDict size = (numOfMethods +1)];
		should: [userStory methodDict includesKey: scenario].
		
	"ACTestRootComponent is hard coded in ACUserStory, as of now"
	"generate empty renderContentOn:"
	storedMethod := ACTestRootComponent methodDict at: #renderContentOn: ifAbsent: [self error].
	[ACTestRootComponent methodDict removeKey: #renderContentOn:.
	self should: [(userStory run: scenario) hasFailures].
	] ensure: [ACTestRootComponent methodDict at: #renderContentOn: put: storedMethod].
	
	self should: [(userStory run: scenario)  hasPassed].! !
